import sys
from Utility import Utility
from Solution import Solution
from Helpers import Helper

class Driver:

    def __init__(self):
        if len(sys.argv) < 2:
            print("Please provide the testcase filepath as a command line argument")
            return
        input = Utility().read_file(sys.argv[1])
        s = Solution(input.graph, input.k)
        solution = s.output_clauses()
        print("Your Solution")
        print("=============================================")
        print(solution)
        print("=============================================")
        helper = Helper()
        helper.write_cnf(helper.convert_format(solution, input.k), input)
        print("Please submit the formula.txt file generated in the current directory to Autolab to run the solver on your SAT formula")

Driver()

