class Helper:

    def __init(self):
        pass

    def convert_format(self, solution, k):

        """
        :param solution: Student solution in the specified format
        :param k: No. of available colors
        :return: Flattened list of clauses

         Convert from the student solution format to the
         standard cnf form accepted by the solver

         ------------------------------SAMPLE------------------------------

         ([(0, 1), (0, 2)], []) -> 1, 2
         ([(1, 1), (1, 2)], []) -> 3, 4
         ([(2, 1), (2, 2)], []) -> 5, 6

         ([], [(0, 1), (0, 2)]) -> -1, -2
         ([], [(1, 1), (1, 2)]) -> -3, -4
         ([], [(2, 1), (2, 2)]) -> -5, -6

         ([(0, 1)], [(0, 2)]) -> 1, -2
         ([(1, 1)], [(1, 2)]) -> 3, -4
         ([(2, 1)], [(2, 2)]) -> 5, -6

         ([(0, 1), (0, 2), (0, 3)], []) -> 1, 2, 3
         ([(1, 1), (1, 2), (1, 3)], []) -> 4, 5, 6
         ([(2, 1), (2, 2), (2, 3)], []) -> 7, 8, 9

         """

        result = []

        for sol in solution:
            temp = []

            # Convert and flatten positive literals
            for literal in sol[0]:
                node, color = literal
                temp.append(color + node * k)

            # Convert and flatten negative literals
            for literal in sol[1]:
                node, color = literal
                temp.append(-(color + node * k))

            result.append(temp)

        return result

    def write_cnf(self, clauses, input):

        """

        :param clauses: List of flattened clauses
        :param input: Graph and k
        :return:
        """

        with open("formula.txt", "w") as f:
            print(f'p cnf {(len(input.graph)*input.k)} {len(clauses)}', file=f)
            for clause in clauses:
                for variable in clause:
                    print(f'{variable} ', end='', file=f)
                print('0 ', file=f)